import { BlockPermutation, ItemStack, Vector } from '@minecraft/server';
import { getDirectionOffset } from 'direction_offset';
function updateLiquid(liquid_dimension, block_location) {
    liquid_dimension.fillBlocks(Vector.add(block_location, { x: 0, y: -1, z: 0 }), Vector.add(block_location, { x: 0, y: -1, z: 0 }), 'minecraft:water', {
        matchingBlock: BlockPermutation.resolve('minecraft:air')
    });
    liquid_dimension.fillBlocks({ x: block_location.x + 1, y: block_location.y, z: block_location.z }, { x: block_location.x + 1, y: block_location.y, z: block_location.z }, 'minecraft:water', {
        matchingBlock: BlockPermutation.resolve('minecraft:air')
    });
    liquid_dimension.fillBlocks({ x: block_location.x, y: block_location.y, z: block_location.z - 1 }, { x: block_location.x, y: block_location.y, z: block_location.z - 1 }, 'minecraft:water', {
        matchingBlock: BlockPermutation.resolve('minecraft:air')
    });
    liquid_dimension.fillBlocks({ x: block_location.x, y: block_location.y, z: block_location.z + 1 }, { x: block_location.x, y: block_location.y, z: block_location.z + 1 }, 'minecraft:water', {
        matchingBlock: BlockPermutation.resolve('minecraft:air')
    });
    liquid_dimension.fillBlocks({ x: block_location.x, y: block_location.y + 1, z: block_location.z }, { x: block_location.x, y: block_location.y + 1, z: block_location.z }, 'minecraft:water', {
        matchingBlock: BlockPermutation.resolve('minecraft:air')
    });
    liquid_dimension.fillBlocks({ x: block_location.x - 1, y: block_location.y, z: block_location.z }, { x: block_location.x - 1, y: block_location.y, z: block_location.z }, 'minecraft:water', {
        matchingBlock: BlockPermutation.resolve('minecraft:air')
    });
    liquid_dimension.fillBlocks({ x: block_location.x, y: block_location.y - 1, z: block_location.z }, { x: block_location.x, y: block_location.y - 1, z: block_location.z }, 'minecraft:air', {
        matchingBlock: BlockPermutation.resolve('minecraft:water')
    });
    liquid_dimension.fillBlocks({ x: block_location.x + 1, y: block_location.y, z: block_location.z }, { x: block_location.x + 1, y: block_location.y, z: block_location.z }, 'minecraft:air', {
        matchingBlock: BlockPermutation.resolve('minecraft:water')
    });
    liquid_dimension.fillBlocks({ x: block_location.x, y: block_location.y, z: block_location.z - 1 }, { x: block_location.x, y: block_location.y, z: block_location.z - 1 }, 'minecraft:air', {
        matchingBlock: BlockPermutation.resolve('minecraft:water')
    });
    liquid_dimension.fillBlocks({ x: block_location.x, y: block_location.y, z: block_location.z + 1 }, { x: block_location.x, y: block_location.y, z: block_location.z + 1 }, 'minecraft:air', {
        matchingBlock: BlockPermutation.resolve('minecraft:water')
    });
    liquid_dimension.fillBlocks({ x: block_location.x, y: block_location.y + 1, z: block_location.z }, { x: block_location.x, y: block_location.y + 1, z: block_location.z }, 'minecraft:air', {
        matchingBlock: BlockPermutation.resolve('minecraft:water')
    });
    liquid_dimension.fillBlocks({ x: block_location.x - 1, y: block_location.y, z: block_location.z }, { x: block_location.x - 1, y: block_location.y, z: block_location.z }, 'minecraft:air', {
        matchingBlock: BlockPermutation.resolve('minecraft:water')
    });
}
export const BUCKET_ENTITIES = new Map([
    ['smokey_bedrock:bucket_nautilus', 'smokey_bedrock:nautilus'],
    ['smokey_bedrock:bucket_squid', 'minecraft:squid'],
    ['smokey_bedrock:bucket_squid_glow', 'minecraft:glow_squid'],
    ['smokey_bedrock:bucket_jellyfish', 'smokey_bedrock:jellyfish']
]);
export const BUCKETABLE_ENTITIES = new Map([
    ['minecraft:nautilus', 'smokey_bedrock:bucket_nautilus'],
    ['minecraft:squid', 'smokey_bedrock:bucket_squid'],
    ['minecraft:glow_squid', 'smokey_bedrock:bucket_squid_glow'],
    ['smokey_bedrock:jellyfish', 'smokey_bedrock:bucket_jellyfish']
]);
export function placeScentedCandle(eventData) {
    const PLAYER = eventData.player;
    let effects = PLAYER.getEffects();
    PLAYER.dimension
        .getBlock(Vector.add(eventData.block.location, getDirectionOffset(eventData.blockFace)))
        .setType(`smokey_bedrock:candle_${effects[0].typeId}`);
}
export function placeBucketEntity(eventData, entity) {
    let PLAYER = eventData.player;
    const SOURCE_DIMENSION = PLAYER.dimension;
    let item = new ItemStack('minecraft:bucket', 1);
    let inventory_component = PLAYER.getComponent('minecraft:inventory');
    inventory_component.container.setItem(PLAYER.selectedSlot, item);
    SOURCE_DIMENSION.getBlock(Vector.add(eventData.block.location, getDirectionOffset(eventData.blockFace))).setType('minecraft:water');
    updateLiquid(SOURCE_DIMENSION, Vector.add(eventData.block.location, getDirectionOffset(eventData.blockFace)));
    SOURCE_DIMENSION.spawnEntity(entity, Vector.add(eventData.block.location, getDirectionOffset(eventData.blockFace)));
}
export function pickupBucketEntity(eventData, entity) {
    let PLAYER = eventData.player;
    let item = new ItemStack(entity, 1);
    let inventory_component = PLAYER.getComponent('minecraft:inventory');
    inventory_component.container.setItem(PLAYER.selectedSlot, item);
}
